/////////////////////////////////////////////////////////
// ACKNEX Engine - engine function list
// (c) oP group / jcl 
/////////////////////////////////////////////////////////
// functions in uppercase letters are not exported
// functions marked with FUNCX are not available in C-Script

FUNC(_chr,ARG1(NUM))
FUNC(_str,ARG1(NUM))
FUNC(_vec,ARG3(NUM,NUM,NUM))
FUNC(absv,ARG1(NUM))
FUNCN(ABS,absv,ARG1(NUM))
FUNC(accelerate,ARG3(VEC,NUM,NUM))

FUNCN(ACOS,acosv,ARG1(NUM))
FUNC(acosv,ARG1(NUM))

FUNC(add_buffer,ARG3(NUM,NUM,NUM))
FUNC(add_folder,ARG1(NUM))
FUNC(add_new,ARG0)
FUNC(add_resource,ARG1(NUM))
FUNC(add_struct,ARG2(NUM,NUM))

FUNC(ang,ARG1(NUM))
FUNC(ang_add,ARG2(VEC,VEC))
FUNC(ang_diff,ARG3(VEC,VEC,VEC))
FUNC(ang_for_axis,ARG3(VEC,VEC,NUM))
FUNC(ang_for_bone,ARG3(VEC,NUM,NUM))
FUNCX(ang_for_matrix)
FUNC(ang_rotate,ARG2(VEC,VEC))
FUNCX(ang_to_matrix)

FUNCN(ASIN,asinv,ARG1(NUM))
FUNC(asinv,ARG1(NUM))
FUNCN(ATAN,atanv,ARG1(NUM))
FUNC(atanv,ARG1(NUM))
FUNCN(ATAN2,atan2v,ARG2(NUM,NUM))
FUNC(atan2v,ARG2(NUM,NUM))

FUNC(beep,ARG0)

FUNC(bmap_create,ARG1(NUM))
FUNC(bmap_createblack,ARG3(NUM,NUM,NUM))
FUNCX(bmap_createpart)
FUNC(bmap_blit,ARG4(NUM,NUM,VEC,VEC))
FUNCX(bmap_blitpart)
FUNC(bmap_fill,ARG3(NUM,NUM,NUM))
FUNC(bmap_format,ARG1(NUM))
FUNC(bmap_for_entity,ARG2(NUM,NUM))
FUNC(bmap_for_buffer,ARG1(NUM))
FUNC(bmap_for_screen,ARG3(NUM,NUM,NUM))
FUNC(bmap_for_texture,ARG1(NUM))
FUNC(bmap_height,ARG1(NUM))
FUNC(bmap_lock,ARG2(NUM,NUM))
FUNC(bmap_preload,ARG1(NUM))
FUNC(bmap_purge,ARG1(NUM))
FUNC(bmap_unlock,ARG1(NUM))
FUNC(bmap_load,ARG3(NUM,NUM,NUM))
FUNC(bmap_remove,ARG1(NUM))
FUNC(bmap_process,ARG3(NUM,NUM,NUM))
FUNC(bmap_save,ARG2(NUM,NUM))
FUNC(bmap_to_alpha,ARG2(NUM,NUM))
FUNC(bmap_to_cubemap,ARG1(NUM))
FUNC(bmap_to_mipmap,ARG1(NUM))
FUNC(bmap_to_normals,ARG2(NUM,NUM))
FUNC(bmap_to_format,ARG2(NUM,NUM))
FUNC(bmap_to_uv,ARG1(NUM))
FUNC(bmap_width,ARG1(NUM))
FUNC(bmap_zbuffer,ARG1(NUM))
FUNC(bmap_rendertarget,ARG3(NUM,NUM,NUM))

FUNC(button_state,ARG3(NUM,NUM,NUM))

FUNC(c_content,ARG2(VEC,NUM)) 
FUNCX(c_ignore)
FUNCX(c_intersect)
FUNC(c_move,ARG4(NUM,VEC,VEC,NUM)) 
FUNC(c_rotate,ARG3(NUM,VEC,NUM)) 
FUNC(c_scan,ARG4(VEC,VEC,VEC,NUM))
FUNC(c_setminmax,ARG1(NUM)) 
FUNC(c_trace,ARG3(VEC,VEC,NUM)) 
FUNC(c_updatehull,ARG2(NUM,NUM))

FUNC(cd_pause,ARG0)
FUNC(cd_play,ARG2(NUM,NUM))
FUNC(cd_start,ARG0)
FUNC(cd_track,ARG0)

FUNC(clamp,ARG3(NUM,NUM,NUM))
FUNC(client_drop,ARG1(NUM))
FUNC(client_drop_id,ARG1(NUM))
FUNC(client_find,ARG2(NUM,NUM))
FUNCN(content,content,ARG1(VEC))
FUNC(cosv,ARG1(NUM))
FUNCN(COS,cosv,ARG1(NUM))
FUNC(cycle,ARG3(NUM,NUM,NUM))
FUNC(diag,ARG1(NUM))
FUNC(diag_frame,ARG1(VEC))
FUNC(diag_status,ARG0)
FUNC(diag_var,ARG2(NUM,NUM))
FUNC(digits_set,ARG3(NUM,NUM,VEC))

FUNCN(DLL_CLOSE,dll_close_c,ARG1(NUM))
FUNCN(DLL_EXEC,dll_exec_c,ARG2(NUM,NUM))
FUNCN(DLL_EXEC_VEC,dll_exec_vec_c,ARG2(NUM,VEC))
FUNCN(DLL_OPEN,dll_open,ARG1(NUM))

FUNC(draw_begin,ARG0)
FUNC(draw_box3d,ARG4(VEC,VEC,VEC,NUM))
FUNC(draw_line,ARG3(VEC,VEC,NUM))
FUNC(draw_line3d,ARG3(VEC,VEC,NUM))
FUNCX(draw_obj)
FUNC(draw_point3d,ARG4(VEC,VEC,NUM,NUM))
FUNCX(draw_quad)
FUNC(draw_text,ARG4(NUM,NUM,NUM,VEC))
FUNC(draw_textmode,ARG4(NUM,NUM,NUM,NUM))
FUNCX(dtimer)

FUNC(effect,ARG4(NUM,NUM,VEC,VEC))
FUNC(effect_cpy,ARG2(NUM,NUM))
FUNC(effect_layer,ARG4(NUM,NUM,VEC,VEC))
FUNC(effect_load,ARG2(NUM,NUM))
FUNC(effect_local,ARG4(NUM,NUM,VEC,VEC))

FUNC(engine_getvar,ARG2(NUM,NUM))

FUNCN(ENT_ALPHASET,A4_ConvertAlpha_c,ARG2(NUM,NUM))
FUNC(ent_animate,ARG4(NUM,NUM,NUM,NUM))
FUNCX(ent_animatefrom)
FUNC(ent_blend,ARG3(NUM,NUM,NUM))
FUNCX(ent_blendframe)
FUNC(ent_blendpose,ARG4(NUM,NUM,NUM,NUM))
FUNC(ent_bonehandle,ARG3(NUM,NUM,NUM))
FUNC(ent_bonemove,ARG3(NUM,NUM,VEC))
FUNC(ent_bonename,ARG3(NUM,NUM,NUM))
FUNC(ent_boneparent,ARG3(NUM,NUM,NUM))
FUNC(ent_bonereset,ARG2(NUM,NUM))
FUNC(ent_bonereset_all,ARG1(NUM))
FUNC(ent_bonereset_branch,ARG2(NUM,NUM))
FUNC(ent_bonerotate,ARG3(NUM,NUM,VEC))
FUNC(ent_bonerotate_parent,ARG3(NUM,NUM,VEC))
FUNC(ent_bones,ARG1(NUM))
FUNC(ent_bonescale,ARG3(NUM,NUM,VEC))
FUNCX(ent_buffers)
FUNC(ent_clone,ARG1(NUM))
FUNC(ent_cloneskin,ARG1(NUM))
FUNC(ent_nextlight,ARG2(NUM,NUM))
FUNCN(ENT_CONTENT,entcontent_c,ARG2(NUM,VEC))
FUNC(ent_create,ARG3(NUM,VEC,NUM))
FUNC(ent_createlayer,ARG3(NUM,NUM,NUM))
FUNC(ent_createlocal,ARG3(NUM,VEC,NUM))
FUNCX(ent_createterrain)
FUNCN(ENT_CYCLE,entcycle_c,ARG2(NUM,NUM))
FUNC(ent_decal,ARG4(NUM,NUM,NUM,NUM))
FUNC(ent_fixnormals,ARG2(NUM,NUM))
FUNCN(ENT_FRAME,entframe_c,ARG2(NUM,NUM))
FUNC(ent_for_file,ARG1(NUM))
FUNC(ent_for_name,ARG1(NUM))
FUNC(ent_frames,ARG1(NUM))
FUNC(ent_mesh,ARG2(NUM,NUM))
FUNC(ent_getdecal,ARG3(NUM,NUM,NUM))
FUNC(ent_getmesh,ARG3(NUM,NUM,NUM))
FUNC(ent_getskin,ARG2(NUM,NUM))
FUNC(ent_getvertex,ARG3(NUM,NUM,NUM))
FUNC(ent_morph,ARG2(NUM,NUM))
FUNC(ent_morphskin,ARG2(NUM,NUM))
FUNCN(ent_move,ent_move,ARG2(VEC,VEC))
FUNC(ent_mtlset,ARG3(NUM,NUM,NUM))
FUNC(ent_next,ARG1(NUM))
FUNC(ent_nextlight,ARG2(NUM,NUM))
FUNCN(ENT_NEXTPATH,A4_NextPath,ARG0)
FUNCN(ENT_NEXTPOINT,ent_nextpoint_c,ARG1(VEC))
FUNC(ent_nextvertex,ARG2(NUM,NUM))
FUNCN(ENT_PATH,ent_path_c,ARG1(NUM))
FUNC(ent_playloop,ARG3(NUM,NUM,NUM))
FUNC(ent_playsound,ARG3(NUM,NUM,NUM))
FUNC(ent_preload,ARG1(NUM))
FUNCN(ENT_PREVPOINT,ent_prevpoint_c,ARG1(VEC))
FUNC(ent_purge,ARG1(NUM))
FUNC(ent_pvs,ARG2(NUM,NUM))
FUNC(ent_reload,ARG1(NUM))
FUNC(ent_remove,ARG1(NUM))
FUNCN(ENT_VERTEX,ent_vertex,ARG2(VEC,NUM))	// old
FUNC(ent_sendnow,ARG1(NUM))
FUNC(ent_setmesh,ARG4(NUM,NUM,NUM,NUM))
FUNC(ent_setskin,ARG3(NUM,NUM,NUM))
FUNC(ent_setvertex,ARG3(NUM,NUM,NUM))
FUNC(ent_skins,ARG1(NUM))
FUNC(ent_status,ARG2(NUM,NUM))
FUNC(ent_type,ARG1(NUM))
FUNC(ent_vertices,ARG1(NUM))
FUNCN(ENT_WAYPOINT,ent_waypoint_c,ARG2(VEC,NUM))

FUNC(error,ARG1(NUM))
FUNC(exec,ARG2(NUM,NUM))
FUNC(exec_wait,ARG2(NUM,NUM))
FUNC(execute,ARG1(NUM))
FUNC(expv,ARG1(NUM))
FUNCN(EXP,expv,ARG1(NUM))
FUNC(facos,ARG2(NUM,NUM))
FUNC(fasin,ARG2(NUM,NUM))
FUNC(fatan,ARG2(NUM,NUM))
FUNC(fcos,ARG2(NUM,NUM))
FUNC(floorv,ARG1(NUM))
FUNCN(FLOOR,floorv,ARG1(NUM))

FUNC(file_asc_read,ARG1(NUM))
FUNC(file_asc_write,ARG2(NUM,NUM))
FUNC(file_chr_read,ARG2(NUM,NUM))
FUNC(file_close,ARG1(NUM))
FUNC(file_cpy,ARG2(NUM,NUM))
FUNC(file_date,ARG1(NUM))
FUNC(file_delete,ARG1(NUM))
FUNC(file_exists,ARG1(NUM))
FUNC(file_find,ARG2(NUM,NUM))
FUNC(file_for_screen,ARG2(NUM,NUM))
FUNC(file_length,ARG1(NUM))
FUNC(file_load,ARG3(NUM,NUM,VEC))
FUNC(file_open_append,ARG1(NUM))
FUNC(file_open_game,ARG1(NUM))
FUNC(file_open_read,ARG1(NUM))
FUNC(file_open_write,ARG1(NUM))
FUNC(file_rename,ARG2(NUM,NUM))
FUNC(file_save,ARG3(NUM,NUM,NUM))
FUNC(file_seek,ARG3(NUM,NUM,NUM))
FUNC(file_str_read,ARG2(NUM,NUM))
FUNC(file_str_readto,ARG4(NUM,NUM,NUM,NUM))
FUNC(file_str_readtow,ARG4(NUM,NUM,NUM,NUM))
FUNC(file_str_write,ARG2(NUM,NUM))
FUNC(file_str_writeto,ARG3(NUM,NUM,NUM))
FUNC(file_var_read,ARG1(NUM))
FUNC(file_var_write,ARG2(NUM,NUM))

FUNCN(FIXED,_var,ARG1(NUM))
FUNCN(FLOAT,floatv,ARG1(NUM))
FUNCN(FLOATD,floatd,ARG2(NUM,NUM))
FUNCN(FLOATR,floatr,ARG1(NUM))
FUNC(floatd,ARG2(NUM,NUM))
FUNC(floatr,ARG1(NUM))
FUNC(floatv,ARG1(NUM))
FUNC(font_create,ARG1(NUM))
FUNC(font_remove,ARG1(NUM))
FUNC(fsin,ARG2(NUM,NUM))
FUNC(ftan,ARG2(NUM,NUM))
FUNC(fraction,ARG1(NUM))
FUNCN(FRC,fraction,ARG1(NUM))
FUNC(game_save,ARG3(NUM,NUM,NUM))
FUNC(game_load,ARG2(NUM,NUM))
FUNC(handle,ARG1(NUM))
FUNCN(INKEY,inkey,ARG1(NUM))
FUNC(integer,ARG1(NUM))
FUNCN(INT,integer,ARG1(NUM))
FUNC(key_for_str,ARG1(NUM))
FUNC(key_pressed,ARG1(NUM))
FUNC(key_set,ARG2(NUM,NUM))

FUNC(layer_sort,ARG2(NUM,NUM))
FUNC(level_load,ARG1(NUM))
FUNC(level_mark,ARG0)
FUNC(level_free,ARG0)
FUNC(logv,ARG1(NUM))
FUNCN(LOG,logv,ARG1(NUM))
FUNC(log10v,ARG1(NUM))
FUNCN(LOG10,log10v,ARG1(NUM))

FUNC(mat_effect,ARG1(VEC))
FUNC(mat_identity,ARG1(VEC))
FUNC(mat_inverse,ARG2(VEC,VEC))
FUNC(mat_multiply,ARG2(VEC,VEC))
FUNC(mat_scale,ARG4(VEC,NUM,NUM,NUM))
FUNC(mat_set,ARG2(VEC,VEC))
FUNC(mat_transpose,ARG2(VEC,VEC))

FUNC(maxv,ARG2(NUM,NUM))
FUNCN(MAX,maxv,ARG2(NUM,NUM))

FUNC(media_loop,ARG3(NUM,NUM,NUM))
FUNC(media_pause,ARG1(NUM))
FUNC(media_play,ARG3(NUM,NUM,NUM))
FUNC(media_playing,ARG1(NUM))
FUNC(media_start,ARG1(NUM))
FUNC(media_stop,ARG1(NUM))
FUNC(media_tune,ARG4(NUM,NUM,NUM,NUM))

FUNC(minv,ARG2(NUM,NUM))
FUNCN(MIN,minv,ARG2(NUM,NUM))

FUNC(mtl_create,ARG0)
FUNC(mtl_remove,ARG1(NUM))

FUNC(pan_create,ARG2(NUM,NUM))
FUNC(pan_getpos,ARG4(NUM,NUM,NUM,VEC))
FUNC(pan_remove,ARG1(NUM))
FUNC(pan_setbmap,ARG4(NUM,NUM,NUM,NUM))
FUNCX(pan_setbutton)
FUNC(pan_setcolor,ARG4(NUM,NUM,NUM,VEC))
FUNCX(pan_setdigits)
FUNC(pan_setevent,ARG4(NUM,NUM,NUM,NUM))
FUNCX(pan_setneedle)
FUNC(pan_setpos,ARG4(NUM,NUM,NUM,VEC))
FUNCX(pan_setslider)
FUNCX(pan_setstring)
FUNC(pan_setvar,ARG4(NUM,NUM,NUM,VEC))
FUNCX(pan_setwindow)

FUNC(path_create,ARG3(NUM,NUM,NUM))
FUNC(path_getedge,ARG4(NUM,NUM,NUM,VEC))
FUNC(path_getnode,ARG4(NUM,NUM,VEC,VEC))
FUNC(path_length,ARG1(NUM))
FUNC(path_next,ARG1(NUM))
FUNC(path_nextnode,ARG3(NUM,NUM,NUM))
FUNC(path_scan,ARG4(NUM,VEC,VEC,VEC))
FUNC(path_scannode,ARG2(NUM,NUM))
FUNC(path_scanpath,ARG4(NUM,VEC,VEC,VEC))
FUNC(path_set,ARG2(NUM,NUM))
FUNC(path_setedge,ARG4(NUM,NUM,NUM,VEC))
FUNC(path_setnode,ARG4(NUM,NUM,VEC,VEC))
FUNC(path_spline,ARG3(NUM,VEC,NUM))

FUNC(pixel_for_bmap,ARG3(NUM,NUM,NUM))
FUNC(pixel_to_bmap,ARG4(NUM,NUM,NUM,NUM))
FUNC(pixel_for_vec,ARG3(VEC,NUM,NUM))
FUNC(pixel_to_vec,ARG4(VEC,VEC,NUM,NUM))

#ifdef PHYSICS_ODE
FUNC(ph_selectgroup,ARG1(NUM))
FUNC(ph_setgravity,ARG1(VEC))
FUNC(ph_setcollisions,ARG2(NUM,NUM))
FUNC(ph_setcontacts,ARG4(VEC,VEC,VEC,VEC))
FUNC(ph_setcorrections,ARG2(NUM,NUM))
FUNC(ph_setautodisable,ARG4(NUM,NUM,NUM,NUM))
FUNC(phent_settype,ARG3(NUM,NUM,NUM))
FUNC(phent_addcentralforce,ARG2(NUM,VEC))
FUNC(phent_addforceglobal,ARG3(NUM,VEC,VEC))
FUNC(phent_addforcelocal,ARG3(NUM,VEC,VEC))
FUNC(phent_addtorqueglobal,ARG2(NUM,VEC))
FUNC(phent_addtorquelocal,ARG2(NUM,VEC))
FUNC(phent_getvelocity,ARG3(NUM,VEC,VEC))
FUNC(phent_clearvelocity,ARG1(NUM))
FUNC(phent_setmass,ARG3(NUM,NUM,NUM))
FUNC(phent_setfriction,ARG2(NUM,NUM))
FUNC(phent_setmaxspeed,ARG3(NUM,NUM,NUM))
FUNC(phent_setdamping,ARG3(NUM,NUM,NUM))
FUNC(phent_enable,ARG2(NUM,NUM))
FUNC(phent_setgroup,ARG2(NUM,NUM))
FUNC(phent_setelasticity,ARG3(NUM,NUM,NUM))
FUNC(phent_getbounds,ARG3(NUM,NUM,VEC))
FUNC(phcon_add,ARG3(NUM,NUM,NUM))
FUNC(phcon_remove,ARG1(NUM))
FUNC(phcon_setparams1,ARG4(NUM,VEC,VEC,VEC))
FUNC(phcon_setparams2,ARG4(NUM,VEC,VEC,VEC))
FUNC(phcon_setmotor,ARG4(NUM,VEC,VEC,VEC)) 
FUNC(phcon_getposition,ARG2(NUM,VEC))
FUNC(phent_makelocal,ARG3(NUM,VEC,VEC))
FUNC(phent_addobstruction,ARG3(NUM,NUM,VEC))
FUNC(phent_getangvelocity,ARG2(NUM,VEC))
FUNC(phent_addvelcentral,ARG2(NUM,VEC))
FUNC(phent_addvelglobal,ARG3(NUM,VEC,VEC))
FUNC(phent_addvellocal,ARG3(NUM,VEC,VEC))
#endif

FUNC(port_in,ARG1(NUM))
FUNC(port_out,ARG2(NUM,NUM))

FUNCN(POW,powv,ARG2(NUM,NUM))
FUNC(powv,ARG2(NUM,NUM))
FUNC(proc_client,ARG2(NUM,NUM))
FUNC(proc_local,ARG2(NUM,NUM))
FUNC(proc_kill,ARG1(NUM))
FUNCX(proc_kill2)
FUNC(proc_status,ARG1(NUM))
FUNC(proc_status2,ARG2(NUM,NUM))
FUNCN(PTR_FOR_NAME,ent_for_name,ARG1(NUM))
FUNC(ptr_first,ARG1(NUM))
FUNC(ptr_remove,ARG1(NUM))
FUNC(ptr_for_handle,ARG1(NUM))
FUNC(random,ARG1(NUM))
FUNC(randomize,ARG0)
FUNC(random_seed,ARG1(NUM))
FUNC(region_check,ARG3(NUM,VEC,VEC))
FUNC(region_create,ARG3(NUM,VEC,VEC))
FUNC(region_find,ARG2(NUM,NUM))
FUNC(region_set,ARG2(NUM,NUM))
FUNC(region_get,ARG3(NUM,VEC,VEC))

FUNC(rel_for_screen,ARG2(VEC,NUM))
FUNC(rel_to_screen,ARG2(VEC,NUM))
FUNCN(RETURN,return_c,ARG1(NUM))
FUNCN(SCAN_ENTITY,scan_entity,ARG2(VEC,VEC))
FUNCN(SCAN_PATH,scan_path,ARG2(VEC,VEC))

FUNCN(SEND,send_c,ARG1(VEC))
FUNC(send_data_to,ARG3(NUM,NUM,NUM))
FUNC(send_data_id,ARG3(NUM,NUM,NUM))
FUNC(send_skill,ARG2(VEC,NUM))
FUNC(send_skill_id,ARG3(NUM,VEC,NUM))
FUNC(send_skill_to,ARG3(NUM,VEC,NUM))
FUNC(send_string,ARG1(NUM))
FUNC(send_string_id,ARG2(NUM,NUM))
FUNC(send_string_to,ARG2(NUM,NUM))
FUNCN(SEND_VEC,send_vec_c,ARG1(VEC))
FUNC(send_var,ARG1(VEC))
FUNC(send_var_id,ARG2(NUM,VEC))
FUNC(send_var_to,ARG2(NUM,VEC))
FUNC(session_close,ARG0)
FUNC(session_connect,ARG2(NUM,NUM))
FUNC(session_open,ARG1(NUM))

FUNC(sign,ARG1(NUM))
FUNC(sinv,ARG1(NUM))
FUNCN(SIN,sinv,ARG1(NUM))
FUNCN(SLEEP,sleep_c,ARG1(NUM))
FUNC(smooth,ARG2(VEC,NUM))

FUNCX(snd_add)
FUNCX(snd_buffer)
FUNC(snd_create,ARG1(NUM))
FUNC(snd_remove,ARG1(NUM))
FUNC(snd_loop,ARG3(NUM,NUM,NUM))
FUNC(snd_pause,ARG1(NUM))
FUNC(snd_play,ARG3(NUM,NUM,NUM))
FUNC(snd_playing,ARG1(NUM))
FUNC(snd_start,ARG1(NUM))
FUNC(snd_stop,ARG1(NUM))
FUNC(snd_stopall,ARG1(NUM))
FUNC(snd_tune,ARG4(NUM,NUM,NUM,NUM))

FUNC(socket_connect,ARG3(NUM,NUM,NUM))
FUNC(socket_receive,ARG2(NUM,NUM))
FUNC(socket_send,ARG2(NUM,NUM))

FUNC(sqrtv,ARG1(NUM))
FUNCN(SQRT,sqrtv,ARG1(NUM))

FUNC(str_cat,ARG2(NUM,NUM))
FUNC(str_cat_num,ARG3(NUM,NUM,NUM))
FUNC(str_chr,ARG3(NUM,NUM,NUM))
FUNC(str_clip,ARG2(NUM,NUM))
FUNC(str_cmp,ARG2(NUM,NUM))
FUNC(str_cmpi,ARG2(NUM,NUM))
FUNC(str_cmpni,ARG2(NUM,NUM))
FUNC(str_cpy,ARG2(NUM,NUM))
FUNC(str_create,ARG1(NUM))
FUNC(str_cursor,ARG1(NUM))
FUNC(str_for_asc,ARG2(NUM,NUM))
FUNC(str_for_entname,ARG2(NUM,NUM))
FUNC(str_for_entfile,ARG2(NUM,NUM))
FUNC(str_for_id,ARG2(NUM,NUM))
FUNC(str_for_key,ARG2(NUM,NUM))
FUNCX(str_for_float)
FUNCX(str_for_int)
FUNC(str_for_num,ARG2(NUM,NUM))
FUNC(str_getchr,ARG2(NUM,NUM))
FUNC(str_len,ARG1(NUM))
FUNC(str_lwr,ARG1(NUM))
FUNCX(str_printf)
FUNC(str_remove,ARG1(NUM))
FUNC(str_setchr,ARG3(NUM,NUM,NUM))
FUNC(str_stri,ARG2(NUM,NUM))
FUNC(str_to_asc,ARG1(NUM))
FUNCX(str_to_float)
FUNCX(str_to_int)
FUNC(str_to_num,ARG1(NUM))
FUNC(str_trunc,ARG2(NUM,NUM))
FUNC(str_upr,ARG1(NUM))
FUNC(str_width,ARG2(NUM,NUM))

FUNCX(sys_active)
FUNC(sys_exit,ARG1(NUM))
FUNCX(sys_free)
FUNCX(sys_malloc)
FUNCX(sys_marker)
FUNCX(sys_nxalloc)
FUNCX(sys_message)
FUNC(sys_metrics,ARG1(NUM))
FUNC(sys_record,ARG2(NUM,NUM))
FUNC(sys_replay,ARG1(NUM))
FUNC(sys_trial,ARG3(NUM,NUM,NUM))
FUNCX(sys_setstr)
FUNCX(sys_getstr)
FUNCX(sys_setvar)
FUNCX(sys_getvar)

FUNC(tanv,ARG1(NUM))
FUNCN(TAN,tanv,ARG1(NUM))
FUNC(timer,ARG0)

FUNC(txt_addstring,ARG2(NUM,NUM))
FUNC(txt_create,ARG2(NUM,NUM))
FUNC(txt_for_dir,ARG2(NUM,NUM))
FUNC(txt_load,ARG2(NUM,NUM))
FUNC(txt_loadw,ARG2(NUM,NUM))
FUNC(txt_remove,ARG1(NUM))
FUNC(txt_setinvisible,ARG2(NUM,NUM))
FUNC(txt_setvisible,ARG2(NUM,NUM))
FUNC(txt_sort,ARG1(NUM))
FUNC(txt_str,ARG2(NUM,NUM))
FUNCN(trace,trace,ARG2(VEC,VEC))
FUNCN(update,update,ARG2(NUM,NUM))

FUNC(var_for_name,ARG1(NUM))
FUNC(vec_accelerate,ARG4(VEC,VEC,VEC,NUM))
FUNC(vec_add,ARG2(VEC,VEC))
FUNC(vec_bounce,ARG2(VEC,VEC))
FUNC(vec_cross,ARG3(VEC,VEC,VEC))
FUNC(vec_diff,ARG3(VEC,VEC,VEC))
FUNC(vec_dist,ARG2(VEC,VEC))
FUNC(vec_dot,ARG2(VEC,VEC))
FUNC(vec_fill,ARG2(VEC,NUM))
FUNC(vec_inverse,ARG1(VEC))
FUNC(vec_length,ARG1(VEC))
FUNC(vec_lerp,ARG4(VEC,VEC,VEC,NUM))
FUNC(vec_mul,ARG2(VEC,VEC))
FUNC(vec_normalize,ARG2(VEC,NUM))
FUNC(vec_rotate,ARG2(VEC,VEC))
FUNC(vec_rotateaxis,ARG3(VEC,VEC,NUM))
FUNC(vec_rotateback,ARG2(VEC,VEC))
FUNC(vec_scale,ARG2(VEC,NUM))
FUNC(vec_set,ARG2(VEC,VEC))
FUNC(vec_sub,ARG2(VEC,VEC))
FUNC(vec_for_angle,ARG2(VEC,VEC))
FUNC(vec_to_angle,ARG2(VEC,VEC))
FUNC(vec_for_bone,ARG3(VEC,NUM,NUM))
FUNC(vec_for_ent,ARG2(VEC,NUM))
FUNC(vec_for_normal,ARG3(VEC,NUM,NUM))
FUNC(vec_for_vertex,ARG3(VEC,NUM,NUM))
FUNC(vec_for_max,ARG2(VEC,NUM))
FUNC(vec_for_mesh,ARG3(VEC,NUM,NUM))
FUNC(vec_for_min,ARG2(VEC,NUM))
FUNC(vec_for_screen,ARG2(VEC,NUM))
FUNC(vec_for_uv,ARG3(VEC,NUM,NUM))
FUNC(vec_to_ent,ARG2(VEC,NUM))
FUNC(vec_to_mesh,ARG3(VEC,NUM,NUM))
FUNC(vec_to_screen,ARG2(VEC,NUM))
FUNC(vec_to_uv,ARG3(VEC,NUM,NUM))
FUNC(vector,ARG3(NUM,NUM,NUM))

FUNC(view_create,ARG1(NUM))
FUNC(view_check,ARG3(NUM,VEC,VEC))
FUNC(view_to_light,ARG3(NUM,NUM,NUM))
FUNC(view_to_matrix,ARG3(NUM,NUM,NUM))
FUNCX(view_to_split)
FUNCX(video_border)
FUNC(video_set,ARG4(NUM,NUM,NUM,NUM))
FUNC(video_switch,ARG3(NUM,NUM,NUM))
FUNC(video_window,ARG4(VEC,VEC,NUM,NUM))
FUNCN(WAIT,wait_c,ARG1(NUM))
FUNCN(WAITT,waitt_c,ARG1(NUM))
//FUNCN(xtest,xtest_c,ARG2(NUM,NUM))
FUNC(wiimote_handle,ARG1(NUM))
FUNC(breaks,ARG0)

FUNCX(engine_status)
FUNCX(engine_getvar)
FUNCX(engine_getvarinfo)
FUNCX(engine_getobj)
FUNCX(engine_getfunc)
FUNCX(engine_getscript)
FUNCX(engine_getscriptinfo)
FUNCX(engine_gettaskinfo)
FUNCX(engine_callname4)
FUNCX(engine_callscript4)
FUNCX(engine_debugposition)
FUNCX(engine_debugbreakpoint)
FUNCX(engine_debugstep)

