#include "m_link.h"
#include <stdio.h>

m_link::m_link()
{
	LHead = LTail = LPos =NULL;
	Nodes=0;
}

m_link::~m_link()
{
    m_link  *pCur, *pNext;

    pCur = LHead;
    LHead = LTail = LPos = NULL;

    while (pCur != NULL)
    {
        pNext = pCur->LNext;
        delete(pCur);
        pCur = pNext;
    }
	Nodes=0;
}


m_link m_link::CreateLink()
{
	m_link *list=new m_link;
	return *list;
}


void m_link::SetData(void *Data)
{
	this->Data=Data;
}


void * m_link::GetData()
{
	return this->Data;
}


void m_link::Add(void *Data)
{
	m_link *pnew = new m_link();
	pnew->Data =Data;
	pnew->LNext=LHead;
	pnew->LPrev=NULL;

	if (LHead != NULL) LHead->LPrev=pnew;
	LHead = pnew;
	LPos  = pnew;

	if (LTail == NULL) LTail=pnew;
	Nodes++;
}

m_link m_link::Find(void *Data)
{
	m_link *pCur;
	for(pCur=LHead;(pCur!=NULL)&&(pCur->Data!=Data);pCur=pCur->LNext);
	return *pCur;
}


void m_link::Remove()
{
	m_link *pCur,*pNext,*pPrev;
	pCur=LPos;
	
	if (pCur != NULL){
		pPrev = pCur->LPrev;
		pNext = pCur->LNext;
		if(pPrev != NULL){
			pPrev->LNext=pNext;
		} else {
			LHead=pNext;
			LPos =pNext;
		}
		if(pNext != NULL){
			pNext->LPrev=pPrev;
			LPos=pNext;
		} else {
			LTail = pPrev;
			LPos  = pPrev;
		}
		delete(pCur);
	}
Nodes--;
}


void m_link::Remove(void *Data)
{
	*LPos=(m_link)Find(Data);
	Remove();
}

void * m_link::GetFirst()
{
	LPos = LHead;
    if (LPos == NULL)
    {
        return(NULL);
    }

    return(LPos->Data);
}

void * m_link::GetLast()
{
    LPos = LTail;
    if (LPos== NULL)
    {
        return(NULL);
    }

    return(LPos->Data);
}

void * m_link::GetNext()
{
    m_link *pNext;

    if ((LPos == NULL) || (LPos->LNext == NULL))
    {
        return(NULL);
    }

    pNext = LPos->LNext;
    LPos  = pNext;
    return(pNext->Data);
}

void * m_link::GetNext(void *Data)
{
    *LPos = Find(Data);
    return(GetNext());
}

void * m_link::GetPrev()
{
    m_link  *pPrev;

    if ((LPos == NULL) || (LPos->LPrev == NULL))
    {
        return(NULL);
    }

    pPrev = LPos->LPrev;
    LPos  = pPrev;
    return(pPrev->Data);
}

void * m_link::GetPrev(void *Data)
{
    *LPos = Find(Data);
    return(GetPrev());
}

m_link m_link::MoveNext()
{
	m_link *pCur;
	if(LPos!=LTail && LPos->LNext!=NULL)	pCur=LPos->LNext;
	return *pCur;
}

m_link m_link::MovePrev()
{
	m_link *pCur;
	if(LPos!=LHead && LPos->LPrev!=NULL)	pCur=LPos->LPrev;
	return *pCur;
}
