/*
wjbender

typical usage
#include "threadmanager.h"
threadmanager *m_manager;

DWORD WINAPI targetfunction(LPVOID param)
{
	functiondata* data=(functiondata*)param;
	return 0;
}

m_manager= new threadmanager();
m_manager->init(20);
HANDLE h=m_manager->get_handle();
m_manager->add_job(targetfunction,(functiondata*)data);
m_manager->signal_run();
Sleep(1);
return (HANDLE*)h;

*/

#pragma once

#include "stdafx.h"
#include "workerthread.h"
#include <stdio.h>

class _jobs
{
public:
	LPTHREAD_START_ROUTINE pfunc;
	LPVOID param;
};

class threadmanager
{
public:
	threadmanager(void);
	~threadmanager(void);
	
	void init(int threads);
	void add_job(LPTHREAD_START_ROUTINE pfunc,LPVOID param);
	void stop();

	int total_threads();
	int total_jobs();
	HANDLE get_handle();
	void signal_run();

private:	
	
	workerthread* find_free_thread();
	_jobs* find_job();
	

	void remove_empty_threads();
	void remove_job(_jobs* this_job);
	void maintain_thread_amount(int last_amount);
	
	static UINT __stdcall ThreadProc(LPVOID pParam);

	HANDLE my_handle;
	HANDLE hrun;

	m_link *jobs_list;
	m_link *threads_list;

	int initial_amount;
	bool run;
};
