/*
wjbender

typical usage
#include "workerthread.h"
workerthread *m_worker;

DWORD WINAPI targetfunction(LPVOID param)
{
	myfunctiondata* data=(myfunctiondata*)param;
	return 0;
}

m_worker=new workerthread();
HANDLE h=m_worker->get_handle();
m_worker->set_func(targetfunction);
m_worker->set_param((myfunctiondata*)data);
m_worker->signal_run();
Sleep(1);
return (HANDLE*)h;

*/

#pragma once

#include "stdafx.h"
#include "process.h"

class workerthread
{
public:
	workerthread(void);
	~workerthread(void);

	
	bool is_busy();
	HANDLE get_handle();
	void signal_run();
	void set_func(LPTHREAD_START_ROUTINE pfunc);
	void set_param(LPVOID param);
	bool is_free();
	bool is_deleted();

private:	
	HANDLE my_handle;

	HANDLE hrun;
	bool free;
	bool deleted;

	void shutdown();
	LPTHREAD_START_ROUTINE pfunc;

	static UINT __stdcall ThreadProc(LPVOID pParam);

	LPVOID params;
};
