
#include <entmove.c>

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
//declarations
#define cur_point skill10
#define has_path skill11
#define total_points skill12
#define waiting skill13
#define anim skill14
//#define from skill15
//#define to skill16

VECTOR* random_point_radius;
VECTOR* random_points_navmesh;
int num_rnd_nav_points=500;

action go_bob();

//VECTOR* path;
//VECTOR from;
//VECTOR to;
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
void wait_at_position(ENTITY* ent);



/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
/*
	creates random positions on the entire 
	navigational mesh
*/
VECTOR* make_random_nav_points(int points)
{	
	VECTOR* rnd_points=peragro_rnd_pnts(points);
	return rnd_points;
}
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
/*
	random_point_around(origin,radius) creates random position on the
	navigational mesh from origin position to radius limit
*/
VECTOR* rnd_point_radius(VECTOR* from,float radius)
{	
	VECTOR* my_point=peragro_rnd_pnt_radius(from,radius);
	return my_point;
}
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
/*
	points creation
*/
void make_points()
{
	//make some random positions on the navmesh
	random_points_navmesh=make_random_nav_points(num_rnd_nav_points);
	random_seed(0);
}
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
/*
	pathfinding function 
	from towards one of the random positions
*/	
VECTOR* path_to_random_position(ENTITY* ent,int mode,VECTOR* path)
{
	if(ent)
	{
		random_seed=0;
		VECTOR from;VECTOR to;
		
		vec_set(from,ent.x);
		//use random point on navmesh
		if(mode==1)
		vec_set(to,random_points_navmesh[(int)random(num_rnd_nav_points-1)].x);
	
		//use random point in radius
		if(mode==2)
		{
			random_point_radius=peragro_rnd_pnt_radius(from,500);
			if(random_point_radius)
			vec_set(to,vector(random_point_radius.x,random_point_radius.y,random_point_radius.z));
		}
			
		int num_path_pnts;
		//find path "from" to "to"	
		path=peragro_findpath(from,to,num_path_pnts);
	
		
		if(num_path_pnts>0)
		{
			if(path!=NULL)
			{
				ent.cur_point=1;
				ent.total_points=num_path_pnts;
				ent.has_path=1;
				return path;
			}
		}
	}

	ent.has_path=0;
	return NULL;
}
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
/*
	invalidate the path
	wait for few seconds
*/
void wait_at_position(ENTITY* ent)
{
	if(ent)
	{
		ent.cur_point=0;
		ent.has_path=0;
		ent.total_points=0;
		ent.waiting=1;
		wait(-3);
		ent.waiting=0;
	}
}
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
/*
	move through the path point by point
*/
void move_through_path(ENTITY* ent,VECTOR* path)
{
	if(ent!=NULL && ent.has_path==1)
	{

		if(ent.cur_point!=ent.total_points)
		{
			var dist=vec_dist(ent.x,vector(path[ent.cur_point].x,path[ent.cur_point].y,ent.z));

			if(dist<=3)
			{
				ent.cur_point+=1;
			}
			
			ent_faceto(ent,path[ent.cur_point],99999);
			ent.roll=0;
			ent.tilt=0;
			c_move(ent,vector(20*time_step,0,0),NULL,GLIDE);
		
		}
	
		if(ent.cur_point==ent.total_points)
		{
			wait_at_position(ent);
		}
	}
}
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
/*
	bot's main function
*/
action go_bob()
{
	
	while(!me){wait(1);}
	VECTOR* path;
	VECTOR pos;
	vec_set(pos,me.x);
	vec_for_max(pos,me);
	set(me,PASSABLE);
	me.z+=pos.z;

	me.cur_point=0;
	me.has_path=0;
	me.total_points=0;
	me.waiting=0;
	me.anim=0;
	
	while(me)
	{
//	vec_set(camera.x,vector(my.x,my.y,camera.z));
		
	VECTOR vFeet;
	vec_for_min(vFeet,me);
	c_trace(me.x,vector(me.x,me.y,me.z-500),IGNORE_ME | IGNORE_PASSABLE);
	me.z = hit.z - vFeet.z;
		
		//	no path and not waiting
		//	find a path
		
		if(me.has_path==0 && !me.waiting)
		{
			//try a path to one of the global navmesh positions
			path=path_to_random_position(me,1,path);
			//no path found so try a path towards a random
			//position in radius around bot
			//path=path_to_random_position(me,2);
			//nowhere to go,nothing to do
			//if(!path)wait_at_position(me);
		}
		
		//	valid path and not waiting
		//	move through that path
		if(me.has_path==1 && !me.waiting)
		{
			move_through_path(me,path);
		}
		

	
		//	draw some path points
		if(me.has_path==1)
		{
			int cur;
			for(cur=0;cur<me.total_points;cur++)
			{
				
				draw_point3d(vector(path[cur].x,path[cur].y,path[cur].z+15),vector(255,255,0),100,5);
				if(cur==0)
				{
					draw_line3d(vector(path[cur].x,path[cur].y,path[cur].z+15),NULL,100);
					draw_line3d(vector(path[cur].x,path[cur].y,path[cur].z+15),vector(255,255,0),100);
				}
				else
				 draw_line3d(vector(path[cur].x,path[cur].y,path[cur].z+15),vector(255,255,0),100);
			}
		}

		//	animation stuff
		me.anim+= 10 *time_step;
		me.anim%= 100;
	
		if(me.waiting)ent_animate(me, "stand",me.anim, ANM_CYCLE);
		if(!me.waiting)ent_animate(me, "walk",me.anim, ANM_CYCLE);
		
		int i;
		if(random_points_navmesh!=NULL )
		{
			//draw those random positions
			for(i=0;i<num_rnd_nav_points;i++)
			draw_point3d(random_points_navmesh[i].x,COLOR_BLUE,100,5);
		}

		wait(1);
	}
}